rem Code to test new functions in Alarm.opx v5.10
rem
rem Version 0.70(026). Last updated 2 February 2000.
rem Copyright (c) 2000 Symbian Ltd. All Rights Reserved.

DECLARE EXTERNAL
EXTERNAL ShowNumbersInDB:
EXTERNAL TestAddCity:
EXTERNAL TestAddCountry:
EXTERNAL TestEditCity:
EXTERNAL TestEditCountry:
EXTERNAL TestDeleteCity:
EXTERNAL TestDeleteCountry:
EXTERNAL TestDataFileSave:
EXTERNAL TestDataFileRevert:
EXTERNAL AddTempTestCity:
EXTERNAL TestSilentAlarm:
EXTERNAL Ooops:

CONST KTempTestCityName$="AAAAAA"

INCLUDE "ALARM.OXH"
INCLUDE "DATE.OXH"

PROC NewIn510Test:
	TestAddCity:
	TestAddCountry:
	TestEditCity:
	TestEditCountry:
	TestDeleteCity:
	TestDeleteCountry:
	TestDataFileSave:
	TestDataFileRevert:
	TestSilentAlarm:
	PRINT "ALARM.OPX v5.10 Tests Complete. Press a key."
	GET
ENDP

PROC ShowNumbersInDB:
	PRINT "Number of cities in database:",WldNumberOfCities&:
	PRINT "Number of countries in database:",WldNumberOfCountries&:
ENDP

PROC TestAddCity:
	ShowNumbersInDB:
	PRINT "Testing WldAddCity:"
	PRINT "Adding 'Test City' in Germany"
	WldAddCity:("Test City","Germany",46,-44,"69",KDaylightSavingZoneEuropean%,1,66,77)
	
	PRINT "Trying to add it again"
	ONERR A1::
	WldAddCity:("Test City","Germany",46,-44,"69",KDaylightSavingZoneEuropean%,1,66,77)
	Ooops:
	GOTO A1A::
	A1::
	PRINT "-->FAILED to add same city twice"
	A1A::
	ONERR OFF

	PRINT "Trying to add same name, other details"
	ONERR A2::
	WldAddCity:("Test City","France",41,-34,"12",KDaylightSavingZoneNorthern%,4,50,60)
	PRINT "-->PASSED adding same city, other details OK"
	GOTO A2A::
	A2::
	PRINT "-->FAILED to add same city name but with other details"
	A2A::
	ONERR OFF

	PRINT "Trying to add city with same name/country as a ROM city"
	ONERR A3::
	WldAddCity:("Oxford","United Kingdom",46,-44,"69",KDaylightSavingZoneEuropean%,1,66,77)
	Ooops:
	GOTO A3A::
	A3::
	PRINT "-->FAILED to add city with same name/country as a ROM one"
	A3A::
	ONERR OFF

	PRINT "Trying to add city with same name, different country as a ROM city"
	ONERR A4::
	WldAddCity:("Oxford","USA",46,-44,"69",KDaylightSavingZoneEuropean%,1,66,77)
	PRINT "-->PASSED adding same city name, different country as a ROM city OK"
	GOTO A4A::
	A4::
	PRINT "-->FAILED to add city with same name, different country as a ROM one"
	A4A::
	ONERR OFF

	ShowNumbersInDB:
	PRINT "Add city tests completed. Press a key"
	GET
	CLS
ENDP

PROC TestAddCountry:
	ShowNumbersInDB:
	PRINT "Testing WldAddCountry:"
	PRINT "Adding 'Symbian Land' with capital 'Sentinel House'"
	WldAddCountry:("Symbian Land","0","1","2","Sentinel House",44,44,"44",KDaylightSavingZoneEuropean%,0,144,81)
	
	PRINT "Trying to add it again"
	ONERR A1::
	WldAddCountry:("Symbian Land","0","1","2","Sentinel House",44,44,"44",KDaylightSavingZoneEuropean%,0,144,81)
	Ooops:
	GOTO A1A::
	A1::
	PRINT "-->FAILED to add same country twice"
	A1A::
	ONERR OFF

	PRINT "Trying to add same name, other details"
	ONERR A2::
	WldAddCountry:("Symbian Land","3","4","5","Harcourt Street",33,33,"33",KDaylightSavingZoneSouthern%,1,6,99)
	Ooops:
	GOTO A2A::
	A2::
	PRINT "-->FAILED to add same country name but with other details"
	A2A::
	ONERR OFF

	PRINT "Trying to add country with same name/capital as a ROM city"
	ONERR A3::
	WldAddCountry:("USA","0","1","2","Washington, DC",44,44,"44",KDaylightSavingZoneEuropean%,0,144,81)
	Ooops:
	GOTO A3A::
	A3::
	PRINT "-->FAILED to add country with same name/capital as a ROM one"
	A3A::
	ONERR OFF

	PRINT "Trying to add country with same name, different capital as a ROM city"
	ONERR A4::
	WldAddCountry:("USA","0","1","2","London Inner",44,44,"44",KDaylightSavingZoneEuropean%,0,144,81)
	Ooops:
	GOTO A4A::
	A4::
	PRINT "-->FAILED to add country with same name, different capital as a ROM one"
	A4A::
	ONERR OFF

	ShowNumbersInDB:
	PRINT "Add country tests completed. Press a key"
	GET
	CLS
ENDP

PROC TestEditCity:
	ShowNumbersInDB:
	PRINT "Testing WldEditCity:"
	PRINT "Trying to edit the city we added earlier ('Test City'/'Germany')"
	WldEditCity:("Test City","Germany","Test-city","Germany",8,8,"13",KDaylightSavingZoneEuropean%,2,15,15)

	PRINT "Trying to edit a ROM city"
	ONERR A1::
	WldEditCity:("Aachen","Germany","AachenAachen","Germany",1,-1,"11",KDaylightSavingZoneEuropean%,1,66,77)
	PRINT "-->PASSED editing a ROM city OK"
	GOTO A1A::
	A1::
	PRINT "-->FAILED to edit a ROM city"
	A1A::
	ONERR OFF

	PRINT "Trying to edit a city which doesn't exist"
	ONERR A2::
	WldEditCity:("IDoNotExist","NeitherDoI","NowIExist?","SoDoI?",1,-1,"11",KDaylightSavingZoneEuropean%,1,66,77)
	Ooops:
	GOTO A2A::
	A2::
	PRINT "-->FAILED to edit a non-existant city"
	A2A::
	ONERR OFF

	ShowNumbersInDB:
	PRINT "Edit city tests completed. Press a key"
	GET
	CLS
ENDP

PROC TestEditCountry:
	ShowNumbersInDB:
	PRINT "Testing WldEditCountry:"
	PRINT "Trying to edit the country we added earlier ('Symbian Land'-->'Symbian Country')"
	WldEditCountry:("Symbian Land","Symbian Country","0","1","2","Sentinel House")

	PRINT "Trying to edit a ROM country"
	ONERR A1::
	WldEditCountry:("Germany","Deutschland","8","7","13","Berlin")
	PRINT "-->PASSED editing a ROM country OK"
	GOTO A1A::
	A1::
	PRINT "-->FAILED to edit a ROM country"
	A1A::
	ONERR OFF

	PRINT "Trying to edit a country which doesn't exist"
	ONERR A2::
	WldEditCountry:("IDoNotExist","ButNowIDo?","8","8","13","AnywhereButHome")
	Ooops:
	GOTO A2A::
	A2::
	PRINT "-->FAILED to edit a non-existant country"
	A2A::
	ONERR OFF

	ShowNumbersInDB:
	PRINT "Edit country tests completed. Press a key"
	GET
	CLS
ENDP

PROC TestDeleteCity:
	ShowNumbersInDB:
	PRINT "Testing WldDeleteCity:"
	PRINT "Trying to delete the city we added earlier ('Test-City'/'Deutschland')"
	WldDeleteCity:("Test-City","Deutschland")
	PRINT "Trying to delete the city we added earlier ('Test City'/'France')"
	WldDeleteCity:("Test City","France")
	PRINT "Trying to delete the city we added earlier ('Oxford'/'USA')"
	WldDeleteCity:("Oxford","USA")

	PRINT "Trying to delete a city which doesn't exist"
	ONERR A2::
	WldDeleteCity:("NonExistantCity","Germany")
	Ooops:
	GOTO A2A::
	A2::
	PRINT "-->FAILED to delete the non-existant city"
	A2A::
	ONERR OFF

	PRINT "Trying to delete a ROM city"
	ONERR A3::
	WldDeleteCity:("Aachen","Germany") rem Sorry, Aachen, nothing personal!
	Ooops:
	GOTO A3A::
	A3::
	PRINT "-->FAILED to delete the ROM city"
	A3A::
	ONERR OFF

	ShowNumbersInDB:
	PRINT "Delete city tests completed. Press a key"
	GET
	CLS	
ENDP

PROC TestDeleteCountry:
	ShowNumbersInDB:
	PRINT "Testing WldDeleteCountry:"
	PRINT "Trying to delete the country we added earlier ('Symbian Country')"
	WldDeleteCountry:("Symbian Country")

	PRINT "Trying to delete a country which doesn't exist"
	ONERR A2::
	WldDeleteCountry:("NonExistantCountry")
	Ooops:
	GOTO A2A::
	A2::
	PRINT "-->FAILED to delete the non-existant country"
	A2A::
	ONERR OFF

	PRINT "Trying to delete a ROM country"
	ONERR A3::
	WldDeleteCountry:("France") rem Sorry, France, nothing personal!
	Ooops:
	GOTO A3A::
	A3::
	PRINT "-->FAILED to delete the ROM country"
	A3A::
	ONERR OFF

	ShowNumbersInDB:
	PRINT "Delete country tests completed. Press a key"
	GET
	CLS	
ENDP

PROC TestDataFileSave:
	ONERR NoFilePresentYet::
	WldDataFileRevert: rem Remove any stuff added already in prior PROCs
	NoFilePresentYet::
	ONERR OFF
	
	ShowNumbersInDB:
	PRINT "Testing WldDataFileSave:"
	PRINT "Adding a temp test city"
	AddTempTestCity:
	ShowNumbersInDB:

	PRINT "Now calling the save function:"
	WldDataFileSave:
	ShowNumbersInDB:
	PRINT "Now calling the revert function (ensure numbers are the same):"
	WldDataFileRevert:
	ShowNumbersInDB:

	PRINT "Now deleting the test city (and re-saving):"
	WldDeleteCity:(KTempTestCityName$,"USA")
	WldDataFileSave:
	ShowNumbersInDB:

	PRINT "Data File Save test completed. Press a key"
	GET
	CLS
ENDP

PROC TestDataFileRevert:
	ShowNumbersInDB:
	PRINT "Testing WldDataFileRevert:"
	PRINT "Adding a temp test city"
	AddTempTestCity:
	ShowNumbersInDB:

	PRINT "Now calling the revert function:"
	WldDataFileRevert:
	ShowNumbersInDB:
	PRINT "Data File Revert test completed. Press a key"
	GET
	CLS
ENDP

PROC AddTempTestCity:
	WldAddCity:(KTempTestCityName$,"USA",55,-55,"04",KDaylightSavingZoneEuropean%,1,90,80)
ENDP

CONST KTestAlarms%=6

PROC TestSilentAlarm:
LOCAL DTime&,H&(KTestAlarms%),M&(KTestAlarms%),i%,Snd$(KTestAlarms%,KMaxAlarmSoundName%)
	PRINT "Testing some silent and 'normal' alarms (";KTestAlarms%,"in total)"
	Snd$(1)=KAlarmSilenced$
	Snd$(2)="Silent"
	Snd$(3)="Chimes"
	Snd$(4)="Rings"
	Snd$(5)="D:\System\Alarms\Big Ben"
	Snd$(6)="Fanfare"
	i%=1
	DO
		H&(i%)=HOUR :M&(i%)=MINUTE+i%
		IF M&(i%)>59
			M&(i%)=0
			H&(i%)=H&(i%)+1
			IF H&(i%)>23
				H&(i%)=0
			ENDIF
		ENDIF
		DTime&=DTNewDateTime&:(YEAR,MONTH,DAY,H&(i%),M&(i%),0,0)
		AlmSetClockAlarm:(i%-1,DTime&,"Test alarm "+NUM$(i%,9),Snd$(i%),KAlarmClockOnce&)
		DTDeleteDateTime:(DTime&)
		i%=i%+1
	UNTIL i%=KTestAlarms%+1
	PRINT "Alarm tests completed. Press a key"
	GET
	CLS
ENDP

PROC Ooops:
	PRINT "*********************************************"
	PRINT "*Errm, that seems to have worked. Oh dear...*"
	PRINT "*********************************************"
	GET
ENDP